;;;  -*- Hen -*-
;;;; levenshtein-sequence-utf8.scm
;;;; Kon Lovett, Sep '06
;;;; Kon Lovett, Apr 2012

(include "levenshtein-sequence-interface")

(module levenshtein-sequence-utf8 SEQUENCE-OPER

  (import scheme chicken)

  (use
    utf8
    utf8-srfi-13
    type-checks
    type-errors)

(: sequence-length sequence -> number)
(: sequence-prefix-length procedure sequence sequence #!rest sequence -> number)
(: sequence-suffix-length procedure sequence sequence #!rest sequence -> number)
(: sequence-for-each procedure sequence sequence #!rest sequence -> number)
(: subsequence/shared sequence -> sequence)

;;;

(define sequence-length string-length)

(define (sequence-prefix-length f s1 s2 . rest)
  (apply string-prefix-length s1 s2 rest) )

(define (sequence-suffix-length f s1 s2 . rest)
  (apply string-suffix-length s1 s2 rest) )

(define (sequence-for-each f s . rest)
  (let ((i 0))
    (apply string-for-each
      (lambda (c) (f i c) (set! i (fx+ i 1))) s rest) ) )

(define subsequence/shared substring/shared)

) ;module levenshtein-sequence-utf8
